function initImageGenerator() {
	const btn = document.querySelector('[data-generator="download-btn"]');
	btn.addEventListener("click", () => {
		generateAndDownloadImage();
	});

	// タイトルを更新する
	const titleInput = document.getElementById("entry-title");
	const canvasTitles = document.querySelectorAll('[data-generator="generate-title"]');

	// 読み込み時に初期値を表示
	updateCanvasTitles(titleInput.value);

	titleInput.addEventListener("input", () => {
		updateCanvasTitles(titleInput.value);
	});

	// クラス名を更新する
	const radioButtons = document.getElementsByName("canvas-class");

	radioButtons.forEach(radio => {
		radio.addEventListener("change", () => {
			updateCanvasBoxes(radio.value);
		});
	});
}

function generateAndDownloadImage() {
	html2canvas(document.querySelector("#generate-area"), {
		scale: 1.5,
	}).then(canvas => {
		const downloadEle = document.createElement("a");
		downloadEle.href = canvas.toDataURL("image/png");
		const date = new Date();
		const timestamp = date.getTime();
		downloadEle.download = 'image-generator-' + timestamp + '.png';
		downloadEle.click();
	});
}

function updateCanvasTitles(title) {
	const canvasTitles = document.querySelectorAll('[data-generator="generate-title"]');
	canvasTitles.forEach(canvasTitle => {
		canvasTitle.textContent = title;
	});
}

function updateCanvasBoxes(className) {
	const canvasBoxes = document.querySelectorAll('[data-generator="canvas-class"]');
	canvasBoxes.forEach(canvasBox => {
		canvasBox.className = className;
	});
}

// 初期化
initImageGenerator();